import * as react from 'react';
import * as _koobiq_react_core_rsc from '@koobiq-react/core-rsc';
import { PropGetter, HTMLKoobiqProps } from '@koobiq-react/core-rsc';
import { AriaCheckboxGroupProps, CheckboxProps } from '@react-types/checkbox';
import { Orientation } from '@react-types/shared';
import { CheckboxGroupState } from '@react-stately/checkbox';
import { ReactRef } from '@koobiq-react/react-utils';

interface Props extends HTMLKoobiqProps<'div'> {
    /**
     * Ref to the DOM node.
     */
    ref?: ReactRef<HTMLDivElement | null>;
    isDisabled?: boolean;
    /**
     * The axis the checkbox group items should align with.
     * @default "vertical"
     */
    orientation?: Orientation;
    /**
     * React aria onChange event.
     */
    onValueChange?: AriaCheckboxGroupProps['onChange'];
}
type UseCheckboxGroupProps = Omit<Props, 'onChange'> & Omit<AriaCheckboxGroupProps, 'validationBehavior'>;
type ContextType = {
    groupState: CheckboxGroupState;
    isInvalid?: UseCheckboxGroupProps['isInvalid'];
    isDisabled?: CheckboxProps['isDisabled'];
};
declare function useCheckboxGroup(props: UseCheckboxGroupProps): {
    Component: _koobiq_react_core_rsc.As<any>;
    children: react.ReactNode;
    label: react.ReactNode;
    context: ContextType;
    description: react.ReactNode;
    isInvalid: boolean;
    errorMessage: any;
    getGroupProps: PropGetter;
    getLabelProps: PropGetter;
    getWrapperProps: PropGetter;
    getDescriptionProps: PropGetter;
    getErrorMessageProps: PropGetter;
};
type UseCheckboxGroupReturn = ReturnType<typeof useCheckboxGroup>;

export { type ContextType, type UseCheckboxGroupProps, type UseCheckboxGroupReturn, useCheckboxGroup };
