"use client";
"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/use-checkbox-group.ts
var use_checkbox_group_exports = {};
__export(use_checkbox_group_exports, {
  useCheckboxGroup: () => useCheckboxGroup
});
module.exports = __toCommonJS(use_checkbox_group_exports);
var import_react = require("react");
var import_checkbox = require("@react-aria/checkbox");
var import_utils = require("@react-aria/utils");
var import_checkbox2 = require("@react-stately/checkbox");
var import_react_utils = require("@koobiq-react/react-utils");
var import_shared_utils = require("@koobiq-react/shared-utils");
function useCheckboxGroup(props) {
  const {
    as,
    ref,
    children,
    label,
    value,
    name,
    defaultValue,
    isInvalid: isInvalidProp,
    validationState,
    orientation = "vertical",
    isDisabled = false,
    isReadOnly,
    isRequired,
    onValueChange,
    description,
    errorMessage,
    className,
    ...otherProps
  } = props;
  const Component = as || "div";
  const shouldFilterDOMProps = typeof Component === "string";
  const domRef = (0, import_react_utils.useDOMRef)(ref);
  const checkboxGroupProps = (0, import_react.useMemo)(() => {
    return {
      ...otherProps,
      value,
      name,
      "aria-label": (0, import_shared_utils.safeAriaLabel)(otherProps["aria-label"], label),
      defaultValue,
      isRequired,
      isReadOnly,
      orientation,
      validationBehavior: "native",
      isInvalid: validationState === "invalid" || isInvalidProp,
      onChange: (0, import_utils.chain)(props.onChange, onValueChange)
    };
  }, [
    value,
    name,
    label,
    defaultValue,
    isRequired,
    isReadOnly,
    orientation,
    onValueChange,
    isInvalidProp,
    validationState,
    otherProps["aria-label"],
    otherProps
  ]);
  const groupState = (0, import_checkbox2.useCheckboxGroupState)(checkboxGroupProps);
  const {
    labelProps,
    groupProps,
    descriptionProps,
    errorMessageProps,
    isInvalid: isAriaInvalid,
    validationErrors,
    validationDetails
  } = (0, import_checkbox.useCheckboxGroup)(checkboxGroupProps, groupState);
  let isInvalid = checkboxGroupProps.isInvalid || isAriaInvalid;
  const context = (0, import_react.useMemo)(
    () => ({
      isInvalid,
      isDisabled,
      groupState
    }),
    [
      isDisabled,
      isInvalid,
      groupState == null ? void 0 : groupState.value,
      groupState == null ? void 0 : groupState.isDisabled,
      groupState == null ? void 0 : groupState.isReadOnly,
      groupState == null ? void 0 : groupState.isInvalid,
      groupState == null ? void 0 : groupState.isSelected
    ]
  );
  const getGroupProps = (0, import_react.useCallback)(() => {
    return {
      ref: domRef,
      ...(0, import_utils.mergeProps)(
        groupProps,
        (0, import_react_utils.filterDOMProps)(otherProps, {
          enabled: shouldFilterDOMProps
        })
      )
    };
  }, [domRef, groupProps, otherProps]);
  const getLabelProps = (0, import_react.useCallback)(() => {
    return {
      ...labelProps
    };
  }, [labelProps]);
  const getWrapperProps = (0, import_react.useCallback)(() => {
    return {
      role: "presentation",
      "data-orientation": orientation
    };
  }, [orientation]);
  const getDescriptionProps = (0, import_react.useCallback)(
    (props2 = {}) => {
      return {
        ...props2,
        ...descriptionProps
      };
    },
    [descriptionProps]
  );
  const getErrorMessageProps = (0, import_react.useCallback)(
    (props2 = {}) => {
      return {
        ...props2,
        ...errorMessageProps
      };
    },
    [errorMessageProps]
  );
  return {
    Component,
    children,
    label,
    context,
    description,
    isInvalid,
    errorMessage: typeof errorMessage === "function" ? (
      // @ts-ignore
      errorMessage({ isInvalid, validationErrors, validationDetails })
    ) : errorMessage || (validationErrors == null ? void 0 : validationErrors.join(" ")),
    getGroupProps,
    getLabelProps,
    getWrapperProps,
    getDescriptionProps,
    getErrorMessageProps
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  useCheckboxGroup
});
