import * as _koobiq_react_core_rsc from '@koobiq-react/core-rsc';
import { PropGetter, HTMLKoobiqProps } from '@koobiq-react/core-rsc';
import { ReactNode, Ref } from 'react';
import { AriaCheckboxProps } from '@react-types/checkbox';

type CheckboxIconProps = {
    'data-checked': string;
    isSelected: boolean;
    isIndeterminate: boolean;
    disableAnimation: boolean;
    className: string;
};
interface Props extends HTMLKoobiqProps<'input'> {
    /**
     * Ref to the DOM node.
     */
    ref?: Ref<HTMLInputElement>;
    /**
     * The label of the checkbox.
     */
    children?: ReactNode;
    /**
     * Whether the checkbox is disabled.
     * @default false
     */
    isDisabled?: boolean;
    /**
     * The icon to be displayed when the checkbox is checked.
     */
    icon?: ReactNode | ((props: CheckboxIconProps) => ReactNode);
    /**
     * React aria onChange event.
     */
    onValueChange?: AriaCheckboxProps['onChange'];
}
type UseCheckboxProps = Omit<Props, 'defaultChecked'> & Omit<AriaCheckboxProps, 'onChange'>;
declare function useCheckbox(props: UseCheckboxProps): {
    Component: _koobiq_react_core_rsc.As<any>;
    icon: ReactNode | ((props: CheckboxIconProps) => ReactNode);
    children: ReactNode;
    isSelected: boolean;
    isDisabled: boolean;
    isFocused: boolean;
    isHovered: boolean;
    isFocusVisible: boolean;
    getBaseProps: PropGetter;
    getWrapperProps: PropGetter;
    getInputProps: PropGetter;
    getLabelProps: PropGetter;
    getIconProps: () => CheckboxIconProps;
};
type UseCheckboxReturn = ReturnType<typeof useCheckbox>;

export { type CheckboxIconProps, type UseCheckboxProps, type UseCheckboxReturn, useCheckbox };
